clear;
clc;
close;


choice = menu(  'Choose experiment',...
                    'dvur: beton, tam a zpet (otocky)',...
                    'dvur: beton, krivky',...
                    'dvur: trava, ctverec',...
                    'ulice:, kostky mensi, tam a zpet (otocky)');

    switch choice
        case 1
            calibration = 'dvur_kalib.mat';
            im_track = 'beton_sem_tam.mat';
            %vpa_track = 'beton_sem_tam.csv';
        
        case 2
            calibration = 'dvur_kalib.mat';
            im_track = 'beton_cikcak.mat';
            %vpa_track = 'beton_cikcak.csv';
            
        case 3
            calibration = 'dvur_kalib.mat';
            im_track = 'trava_ctverec.mat';
            %vpa_track = 'trava_ctverec.csv';
        
        case 4
            calibration = 'ulice_kalibrace.mat';
            im_track = 'dlazba.mat';
            %vpa_track = 'dlazba.csv';
    end

refresh;close(1) % refresh the menu to close immediately



MA_filter = 5;

calib_pairs = load(calibration);
track_uv = load(im_track);
%vpa_data = importdata(vpa_track);

H = eval_homography(calib_pairs.calib_pairs); 



n = size(calib_pairs.calib_pairs,1); % number of point correspondences

for i = 1:n
 
     uv_h = [calib_pairs.calib_pairs(i,3:4) 1]'; % image coordinates in homogenous coord.
     
     xy_h = H*uv_h;
     
     xy = [xy_h(1)/xy_h(3); xy_h(2)/xy_h(3)];
     
     fprintf('Homography reprojection error %d: x:%f y:%f  m\n', i, abs(calib_pairs.calib_pairs(i,1) - xy(1)), abs(calib_pairs.calib_pairs(i,2) - xy(2)));  
 
 end



track_xyt = uv_2_xy(track_uv.track, H);


% filter output
a = 1;
b = ones(1,MA_filter)/MA_filter;

track_xyt = filtfilt(b,a,track_xyt);

[synch_track synch_vpa] = synch_vpa_and_track(track_xyt);
%%
time_error = evaluate_error_in_time(synch_track, synch_vpa);






figure(2);
subplot(2,1,1);
plot(synch_track(:,1), synch_track(:,2));
grid on;
title('X coordinate [m], track');
legend('Tracked');

subplot(2,1,2);
plot(synch_vpa(:,1), synch_vpa(:,8),'r');
grid on;
title('X coordinate [m], inso');
xlabel('robot time [s]');
ylabel('X coordinate [m]');
legend('INSO');

figure(3);
subplot(2,1,1);
plot(synch_track(:,1), synch_track(:,3));
grid on;
title('Y coordinate [m], Tracked');
xlabel('frames');
ylabel('Y coordinate [m]');
legend('Tracked');

subplot(2,1,2);
plot(synch_vpa(:,1), -synch_vpa(:,9),'r');
grid on;
title('Y coordinate [m], inso');
xlabel('robot time [s]');
ylabel('Y coordinate [m]');
legend('INSO');

figure(1);
hold on;
plot(-synch_track(:,3), synch_track(:,2),'b');
plot(synch_vpa(:,9), synch_vpa(:,8),'r');
grid on;
title('Top view, NWU system');
xlabel('X coordinate [m]');
ylabel('Y coordinate [m]');
legend('Tracked','INSO');

figure(4);
plot(time_error(:,1),time_error(:,2));
grid on;
title('Evolution of position error in time');
xlabel('Time [s]');
ylabel('Position Error [m]');


