function [XY_graphs] = plot_sync_values(track_xyt, time_ref , time_from_zero, vpa_data)

    scrsz = get(0,'ScreenSize');    
    XY_graphs = figure(10);
    set(XY_graphs, 'Position',[scrsz(3)/8 scrsz(4)/8 6*scrsz(3)/8 6*scrsz(4)/8]);
    
    subplot(2,1,1);
    hold on;
    plot(time_ref(:,1), track_xyt(:,2),'b');
    plot(time_from_zero, vpa_data(:,8),'r');
    grid on;
    title('X coordinate [m]');
    legend('Tracked','INSO');
    xlabel('robot time [s]');
    ylabel('X coordinate [m]');

    subplot(2,1,2);
    grid on;
    hold on;
    plot(time_ref(:,1), track_xyt(:,3),'b');
    plot(time_from_zero, -vpa_data(:,9),'r');
    title('Y coordinate [m]');
    xlabel('robot time [s]');
    ylabel('Y coordinate [m]');
    legend('Tracked','INSO'); 
    
end