function [track_interpolated_cropped vpa_cropped]= synch_vpa_and_track(track_txy, vpa_data)
% synch_vpa_and_track imports vpa file and synchronizes track_txy with it
%   and crops both to get maximum overlay 

      %get the vpa file 
%     [infilename, infilepath] = uigetfile('*.csv','Select a _vpa_ log file from INSO');
%     
%     if isequal(infilepath,0) 
%         error('Nothing selected');
%     end
%     
%     vpa_data = importdata(strcat(infilepath,infilename));
    
    %time_beginning = vpa_data(1,1);
    time_from_zero = vpa_data(:,1); %-time_beginning;
    
    while 1
        %% plot X and Y values
        XY_fig_handle = plot_X_and_Y_values(track_txy, time_from_zero, vpa_data);

        % let the user identify the beginning
        start_choice = menu('Using which coordinate (X , Y or heading) would you like to identify the BEGINNING of the experiment ?','X','Y','Heading');

        close(XY_fig_handle);

        if (start_choice == 1)
            fig_handle = plot_X_values(track_txy, time_from_zero, vpa_data);
        else
            if (start_choice == 2)
                fig_handle = plot_Y_values(track_txy, time_from_zero, vpa_data);
            else
                fig_handle = plot_H_values(track_txy, time_from_zero, vpa_data);
            end
        end

        menu('Now, please zoom both plots to the BEGINNING of the experiment, so it is clearly distinguishable','Done');
        menu('By clicking first into the "tracked" plot (blue), then into the red "inso" one, mark the beginning of the experiment.','Start marking');

        % get the beginning coordintes
        start_coords(1,:) = ginput(1);
        figure(fig_handle);
        subplot(2,1,1); hold on; plot(start_coords(1,1),start_coords(1,2),'rO');

        start_coords(2,:) = ginput(1);
        close(fig_handle);

        % plot X and Y values
        XY_fig_handle = plot_X_and_Y_values(track_txy, time_from_zero, vpa_data);

        % let the user identify the end
        end_choice = menu('Using which coordinate (X , Y or heading) would you like to identify the END of the experiment?','X','Y','Heading');
        close(XY_fig_handle);

         if (end_choice == 1)
            fig_handle = plot_X_values(track_txy, time_from_zero, vpa_data);
        else
            if (end_choice == 2)
                fig_handle = plot_Y_values(track_txy, time_from_zero, vpa_data);
            else
                fig_handle = plot_H_values(track_txy, time_from_zero, vpa_data);
            end
        end

        menu('Now, please zoom both plots to the END of the experiment, so it is clearly distinguishable','Done');
        menu('By clicking first into the "tracked" plot (blue), then into the red "inso" one, mark the end of the experiment.','Start marking');

        % get the beginning coordintes
        end_coords(1,:) = ginput(1);
        figure(fig_handle);
        subplot(2,1,1); hold on; plot(end_coords(1,1),end_coords(1,2),'rO');

        end_coords(2,:) = ginput(1);
        close(fig_handle);

        %% time for the reference track

        time_ref = zeros(size(track_txy,1),1);

        % lin. transformation to the reference time

        dataStartT = start_coords(2,1);
        dataEndT = end_coords(2,1);
        refStart = start_coords(1,1);
        refEnd = end_coords(1,1);

        k = (dataStartT-dataEndT) / (refStart-refEnd) ;
        q = dataStartT - k * refStart;

        for n = 1 : size(time_ref,1)

            time_ref(n) = (n) * k + q;

        end
        
        
        %% interpolate
        interp_refXY = interp1(time_ref, track_txy(:,1:3), time_from_zero,'linear');
        interp_refAz = interp1(time_ref, track_txy(:,4), time_from_zero,'nearest');
        
        interp_ref = [interp_refXY interp_refAz];
        
        track_interpolated = [time_from_zero interp_ref(:,2:end)];
        
        %% crop
        start_row = find(max([time_ref(1) time_from_zero(1)]) <= time_from_zero,1,'first')+1;
        end_row = find(min([time_ref(end) time_from_zero(end)]) <= time_from_zero,1,'first')-1;
        
        
        
        %% plot to verify
        XY_fig_handle = plot_sync_values(track_interpolated(start_row:end_row,:), time_from_zero(start_row:end_row,:) ,time_from_zero(start_row:end_row,:), vpa_data(start_row:end_row,:));
        satisfaction = menu('Are you satisfied with the result?','Hell yeah!','No, try again');

        close(XY_fig_handle);
        if(satisfaction == 1); break; end
    end
    
    %% succes, return interpolated and cropped track ans cropped vpa array
    
    track_interpolated_cropped = [time_from_zero(start_row:end_row,:) track_interpolated(start_row:end_row,2:end)];
    vpa_cropped = vpa_data(start_row:end_row,:);
    
    
    
%     figure(1);
%     hold on;
%     plot(-track_xyt(:,3), track_xyt(:,2),'b');
%     plot(vpa_data(:,9), vpa_data(:,8),'r');
%     grid on;
%     title('Top view, NWU system');
%     xlabel('X coordinate [m]');
%     ylabel('Y coordinate [m]');
%     legend('Tracked','INSO');

    
    

end