function [ world_track ] = uv_2_xy( image_track, H )
%UV_2_XY transforms image track to the world original one
%   world_track = [frame, x, y ; ...]
%   image_track = [frame, u, v ; ...]
%   H = 3x3 homography matrix

    frames = size(image_track,1);

    world_track = [image_track(:,1) zeros(frames,2)];

    xy_h = (H*[image_track(:, 2:3) ones(frames,1)]')'; % Transform
      
    world_track(:,2:3) = xy_h(:,1:2) ./ [xy_h(:,3) xy_h(:,3)] ; % Return from homogenous coords.

end

