function [ histColor ] = evaluate_HV_hist( im, noise_variance, smoother_window )
%EVALUATE_HV_HIST based on input image, this function creates 2D histogram
%of hue and saturation and smooths it using the smoother_window by a
%convolution

%needs the 'constraint' function to work

%add noise
im = constraint(im + random('norm',0,noise_variance,[size(im,1) size(im,2) 3]),0,1);

%convert to HSV
im = rgb2hsv(im);

histColor = zeros(100,100);

%evaluate
for i = 1:1:int8(size(im,1))
    for k = 1:1:int8(size(im,2))
        histColor(constraint(int8(round(im(i,k,1)*100)),1,100),constraint(int8(round(im(i,k,2)*100)),1,100)) =...
            histColor(constraint(int8(round(im(i,k,1)*100)),1,100),constraint(int8(round(im(i,k,2)*100)),1,100)) + 1;  
    end
end

%smooth
%mask = ones(3,3)/9;
mask = smoother_window;

histColor = [ histColor ;  histColor ; histColor ];
histColor = conv2(histColor,mask,'same');
histColor = histColor(101:200,:);

end

