classdef MaskCollageBuilder < handle
    %UNTITLED2 Summary of this class goes here
    %   Detailed explanation goes here
    
    properties (Access = protected)
        masks
        rects
        colors
        n = 0
    end
    
    methods
        
        function addMask(obj, mask, rect, color)
            obj.n = obj.n + 1;
            obj.masks{obj.n} = mask;
            obj.rects{obj.n} = rect;
            obj.colors{obj.n} = color;
        end
        
        function [I, r] = getCollage(obj)
            rs = cell2mat(obj.rects');
            r = rectUnion(rs);
            I = zeros(r(4),r(3),3, 'uint8');
            
            for i = 1:obj.n
                ri = obj.rects{i};
                ci = obj.colors{i};
                
                maski = obj.masks{i};
                if isfloat(maski)
                    maski = uint8(maski*255);
                end
                
                Ii = zeros(ri(4), ri(3), 3, 'uint8');
                for j = 1:3
                    Ii(:,:,j) = immultiply(maski, ci(j));
                end
                
                b = [ri(2)-r(2)+1, ri(2)+ri(4)-r(2), ri(1)-r(1)+1, ri(1)+ri(3)-r(1)];
                
                Ic = I(b(1):b(2), b(3):b(4), :);
                Ii = imadd(Ii, Ic);
                I(b(1):b(2), b(3):b(4), :) = Ii;
            end
        end
    end
    
end

