function vr = createVideoReader(fileName)
%vr = createVideoReader(fileName) 
%   Creates new 'mmreader' or 'VideoReader' class depending on their 
%   existence and opens 'fileName' movie file with it.

    if exist('mmreader', 'class')
        vr = mmreader(fileName);
    elseif exist('VideoReader', 'class')
        vr = VideoReader(fileName);
    else
        error('Neither ''mmreader'' nor ''VideoReader'' class exists - movie file cannot be read.');
    end

end
