function [r] = radiusOfMass(weight, percentile, x, y, mask)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

    s = size(weight);
    [xg, yg] = meshgrid((1:s(2)), (1:s(1)));

    if nargin > 4
        xg = xg(mask);
        yg = yg(mask);
        weight = weight(mask);
    end

    d = sqrt((xg-x).^2 + (yg-y).^2);
    d = round(d) + 1;
    
    h = zeros(1,max(d));
    
    for i = 1:numel(d)
        h(d(i)) = h(d(i)) + weight(i);
    end
    
    h = cumsum(h);
    totalWeight = h(end);
    r = find(h > percentile*totalWeight, 1, 'first') - 1;
end
