%robot tracker

refColor=3; % red=1 ,blue=3


referenceIm=im_rgb_joint();
referenceIm=uint8(referenceIm);

movieFile = 'MVI_8226.AVI';
    
vr = VideoReader(movieFile);
    
disp('Video se nahralo')

numberOfFrames = inf;
numberOfFrames = min(numberOfFrames, vr.NumberOfFrames);

im = read(vr, 1);
im = uint8(im);

im=im-referenceIm;

[imSmall rect] = imcrop(im); % rect udava souradnice 1. bodu [x y] plus sirky a vysku
midX = round(rect(1) + rect(3)/2);  % x stred ve vybraem obrazku
midY = round(rect(2) + rect(4)/2);  % y stred ve vybraem obrazku

[imSmall rect] = imcrop(im);
maxDisturbance = max(max(imSmall(:,:,refColor)));
maxDisturbance=maxDisturbance+20;
   
img=zeros(size(im,1),size(im,2));

res_coords=[-1 ; -1];


%----double image setting
mainfig = figure('Position',[0 0 2*480+3*20 360+2*20], 'Resize','off');
movegui(mainfig, 'center');

an1 = annotation('textbox', 'String',{'text...text', 'newline'}, ...
        'Units', 'pixels', ...
        'Interpreter','none' ,...
        'Position', [20 330 50 50], ...
        'FitBoxToText','on', ...
        'BackgroundColor','white', ...
        'LineStyle','none' ...
        );
    
ax1 = axes('Units','pixels', 'Position',[20 20 480 360]);
ax2 = axes('Units','pixels', 'Position',[480+2*20 20 480 360]);

for i = (1:5:numberOfFrames)
    frame = read(vr, i);
    diff_img(:,:)= frame(:,:,refColor)-referenceIm(:,:,refColor);
   
     [midX midY] = color_tracking(midX,midY,maxDisturbance, diff_img);
     
     res_coords=[res_coords, [midX; midY]];

     
%    color_frame_with_cross = drawCross(midX,midY,frame);    
%    imshow(color_frame_with_cross);

     


     imshow(frame,'Parent',ax1)
     line(midX,midY,'Parent',ax1,'Marker','+','MarkerSize',50,'Color','red','LineWidth',1);
     text(20, 20, sprintf('frame: %05d',i), 'BackgroundColor', 'white');
     set(an1, 'String', {...
            sprintf(' frame: %05d ',i),...
            sprintf(' position: x = %4.1f; y = %4.1f ',midX,midY)...
            });

    imshow(diff_img, 'Parent',ax2);
     

     getframe;
end

res_coords=res_coords(:, 2:size(res_coords,2));

figure
imshow(draw_track(frame,res_coords));
title('final track');
