function [] = map3Dto2D ()

    uv = [270 577; 1111 556; 1294 937; 133 992]';
    xyz = [0 0 0; 0 200 0; 137 199 0; 138 0 0]';
    N = 4;

    w = 1600;
    h = 1200;
    cameraCenter = [w/2 h/2]';
    
    uv = bsxfun(@minus, uv, cameraCenter);
    
    
    xyz = [xyz; ones(1,N)];
    
    %A1 = bsxfun(@(x,y) x.*y, xyz, -uv(:,1));
    %A2 = bsxfun(@(x,y) x.*y, xyz, -uv(:,2));
    
    %A = [xyz, zeros(N,4), A1; zeros(N,4), xyz, A2];
    options = optimset('MaxIter', 100000, 'MaxFunEvals', inf, 'TolFun', 1e-5, 'Jacobian', 'on');
    LB = [-800 -500 -500 0 0 0 0.5];
    UB = [0 0 0 pi pi pi 100];
    
    p = [-400 -100 -300, -pi/2 pi/2+0.5 0, 500];
    %p = [0 0 100, 0 0 0, 100];
    [p,~,~,~,output] = lsqnonlin(@(p) objfunc(p, uv, xyz), p, -inf(1,7), inf(1,7), options);
    %p = lsqnonlin(@(p) objfunc(p, uv, xyz), [-300 -200 -200 pi/2 pi/2 0 1], LB, UB);
    %p = lsqnonlin(@(p) objfunc(p, uv, xyz), [0 0 1 0 0 0 1]);
    %p = lsqnonlin(@(p) objfunc(p, uv, xyz), p);
    %output.iterations
    
    
    T = transform(p);
    T = T.T;
        
    objfunc(p, uv, xyz)
    
    I = imread('IMG_0036.JPG');
    imshow(I);
    
    for z = (0:15:120)
        points = bsxfun(@plus, xyz, [0 0 z 0]');
        points = T*points;
        points = bsxfun(@(x,y) x./y, points, points(3,:));
        points = points(1:2,:);
        points = bsxfun(@plus, points, cameraCenter);
        
        drawSquare(points);
    end
    
    h = impoint;
    p2D = wait(h);
    p2D = [p2D(:) - cameraCenter; 1];
    
    z = 30;
    plane3DPoints = [0 0 z 1; 1 0 z 1; 0 1 z 1]';
    
    p3D = from2Dto3DPlane(T, p2D, plane3DPoints)
    
    
    %points = uv2;
    %points = bsxfun(@plus, points, cameraCenter);
    %line(points(1,:), points(2,:), 'LineStyle', 'none', 'Marker', 'x', 'MarkerSize', 10, 'Color', 'red');
end

function [p] = from2Dto3DPlane(T, p2D, plane3DPoints)
    plane3DPoints = T * plane3DPoints;
    plane3DPoints = plane3DPoints(1:3,:);

    b = plane3DPoints(:,1);
    v1 = plane3DPoints(:,2) - b;
    v2 = plane3DPoints(:,3) - b;
    
    p2D = p2D(:);
    if length(p2D) == 2; p2D(3) = 1; end
    
    A = [v1 v2 p2D];
    x = A\b;
    
    alpha = x(3);
    p3D = [alpha * p2D; 1];
    
    p3D = T\p3D;
    p = p3D(1:3);
end

function [] = drawSquare(p)
    p = [p, p(:,1)];
    %line(p(1,:), p(2,:), 'LineStyle', 'none', 'Marker', 'x', 'MarkerSize', 10, 'Color', 'red');
    line(p(1,:), p(2,:), 'LineStyle', '-', 'Marker', 'none', 'MarkerSize', 10, 'Color', 'red');
end

function [err J] = objfunc(p, uv, xyz)
    T = transform(p);
    err = T.T*xyz;
    err = err(1:3,:);
    err = bsxfun(@(x,y) x./y, err, err(3,:));
    err = err(1:2,:);
    err = err - uv;
    err = err(:);
    
    n = size(xyz, 2);
    J = zeros(2*n, length(p));
    for i = (1:n)
        point = T.T * xyz(:,i);
        Ji = T.getJacobian(xyz(:,i));
        
        %Ji = Ji / point(3);
        %Ji(1,:) = Ji(1,:) - point(1,:)*Ji(3,:);
        %Ji(2,:) = Ji(2,:) - point(2,:)*Ji(3,:);
        
        Ji(1,:) = (Ji(1,:)*point(3) - point(1)*Ji(3,:)) / point(3)^2;
        Ji(2,:) = (Ji(2,:)*point(3) - point(2)*Ji(3,:)) / point(3)^2;
        
        J(2*i-1:2*i,:) = Ji(1:2,:);
    end
end

function [T] = transform(p)
    T = Transform3D;
    T.translation(p(1:3));
    T.eulerAngles(p(4), p(5), p(6));
    T.scaleXY(p(7));
end
