function [track_txy] = homografy_main(xyuv, trackingRes, plotResults)

    %  xyuv = [7,7,483,169;...
    %          0,7,181,180;...
    %          0,0,85, 342;...
    %          7,0,568,331];
  
    H = eval_homography(xyuv);    

    %puvodni
    % track = importdata('track_8226.csv');
    % data = track.data;
    
    data = trackingRes.track;

%     track_tuv = [data(:,1) data(:,2)+320 -data(:,3)+240];
    track_tuv = [data(:,1) data(:,2) data(:,3)];

    track_txy = [data(:,1) zeros(size(data,1),2)];

    for i = 1:size(data,1)
        xy_h = H*[track_tuv(i, 2:3) 1]'; % Transform
        track_txy(i,2:3) = [xy_h(1)/xy_h(3); xy_h(2)/xy_h(3)]; %from homogenous to XY
    end
    
    if plotResults
        
        figure();
        imshow(trackingRes.image);
        hold on;
        plot(track_tuv(:,2),track_tuv(:,3), 'r', 'Linewidth', 2);
        title('Tracked Movement');
     
    
        figure();
        plot(-track_txy(:,3),track_txy(:,2));
        axis equal;
        xlabel('Y coordinate [m]');
        ylabel('X coordinate [m]');
        grid on;
        title('Transformed into the world frame');
    end
    
end
